<?php
/**
 * Plugin Name: netfx Core
 * Plugin URI: https://jwsuperthemes.com/
 * Description: Add Themeoption And Function Config for themes.
 * Author: JWSThemes
 * Author URI: https://jwsuperthemes.com/
 * Version: 1.0.0
 * License: GPL3
 * License URI: http://www.gnu.org/licenses/gpl-3.0.txt
 *
 * @package CGB
 */

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Add Post Type.
 */
define("netfxcore", "Active"); 
require_once plugin_dir_path( __FILE__ ) . 'less.php';
require_once plugin_dir_path( __FILE__ ).'login-register-function.php';
include_once( 'ReduxCore/framework.php' );
if(!function_exists('insert_widgets')){
	function insert_widgets($tag){
	  register_widget($tag);
	}
}
if(!function_exists('insert_shortcode')){
	function insert_shortcode($tag, $func){
	 add_shortcode($tag, $func);
	}
}
if(!function_exists('jws_get_contents')){
	function jws_get_contents($tag){
	 return file_get_contents($tag);
	}
}




if(!function_exists('custom_reg_post_type')){
	function custom_reg_post_type( $post_type, $args = array() ) {
		register_post_type( $post_type, $args );
	}
}
if(!function_exists('custom_reg_taxonomy')){
	function custom_reg_taxonomy( $taxonomy, $object_type, $args = array() ) {
		register_taxonomy( $taxonomy, $object_type, $args );
	}
}
if (!function_exists('output_ech')) { 
    function output_ech($ech) {
        echo $ech;
    }
}
if (!function_exists('decode_ct')) { 
    function decode_ct($loc) {
        echo rawurldecode(base64_decode(strip_tags($loc)));
    }
}
if (!function_exists('ct_64')) { 
    function ct_64($ech) {
       return base64_encode($ech);
    }
}
if (!function_exists('ct_65')) { 
    function ct_65($ech) {
       return base64_decode($ech);
    }
}
if(!function_exists('jws_sv_ct3')){
	function jws_sv_ct3($user_email,$name, $subject, $content){
       wp_mail( $user_email,$name, $subject, $content );
	}
}

if(!function_exists('sv_ct')){
	function sv_ct(){
	  return $_SERVER;
	}
}
function jws_run_Plugin() {
    require_once plugin_dir_path( __FILE__ ) .'post_type/show.php';

require_once plugin_dir_path( __FILE__ ). 'post_type/team.php';

require_once plugin_dir_path( __FILE__ ).'post_type/testimonial.php';

require_once plugin_dir_path( __FILE__ ).'post_type/service.php';
require_once plugin_dir_path( __FILE__ ).'post_type/agency.php';
}

add_action('plugins_loaded', 'jws_run_Plugin');

function jws_import_files() {
	return array(
		array(
			'import_file_name'             => 'Import Architecture',
			'categories'                   => array('Architecture'),
			'local_import_file'            => trailingslashit( plugin_dir_path( __FILE__ ) ) . 'import/arc/contents.xml',
			'local_import_widget_file'     => trailingslashit( plugin_dir_path( __FILE__ ) ) . 'import/arc/widgets.wie',
			'local_import_redux'           => array(
				array(
					'file_path'   => trailingslashit( plugin_dir_path( __FILE__ ) ) . 'import/arc/redux.json',
					'option_name' => 'jws_option',
				),
			),
			'import_preview_image_url'     => plugin_dir_url( __FILE__) .'import/lr1.jpg',
			'import_notice'                => __( 'The imort process will take a few minutes, please wait. thank you.', 'netfx' ),
			'preview_url'                  => 'http://netfx.jwsthemeswp.com',
		),
		array(
			'import_file_name'             => 'Import Construction',
			'categories'                   => array( 'Construction' ),
			'local_import_file'            => trailingslashit( plugin_dir_path( __FILE__ ) ) . 'import/cons/contents.xml',
			'local_import_widget_file'     => trailingslashit( plugin_dir_path( __FILE__ ) ) . 'import/cons/widgets.wie',
			'local_import_redux'           => array(
				array(
					'file_path'   => trailingslashit( plugin_dir_path( __FILE__ ) ) . 'import/cons/redux.json',
					'option_name' => 'jws_option',
				),
			),
			'import_preview_image_url'     => trailingslashit(plugin_dir_url( __FILE__)) .'import/lr2.jpg',
			'import_notice'                => __( 'The imort process will take a few minutes, please wait. thank you.', 'netfx' ),
			'preview_url'                  => 'http://netfxcons.jwsthemeswp.com/',
		),
	);
}
add_filter( 'pt-ocdi/import_files', 'jws_import_files' );

if ( ! function_exists( 'jws_after_import' ) ) :
    function jws_after_import($selected_import) {
    
        //Import Revolution Slider
       if ( class_exists( 'RevSlider' ) ) {
           $slider_array = array(
            //   plugin_dir_path( __FILE__ )."import/rev_slider/about_us.zip",
            //   plugin_dir_path( __FILE__ )."import/rev_slider/our_blog_slider.zip",
            //   plugin_dir_path( __FILE__ )."import/rev_slider/our_netfxs_slider.zip",
            //   plugin_dir_path( __FILE__ )."import/rev_slider/our_sevices.zip",
            //   plugin_dir_path( __FILE__ )."import/rev_slider/our-netfx-cou.zip",
            //   plugin_dir_path( __FILE__ )."import/rev_slider/revo_2.zip",
            //   plugin_dir_path( __FILE__ )."import/rev_slider/revo_3.zip",
            //   plugin_dir_path( __FILE__ )."import/rev_slider/revo1.zip",
            //   plugin_dir_path( __FILE__ )."import/rev_slider/slider before header.zip"
           );

           $slider = new RevSlider();
       
           foreach($slider_array as $filepath){
             $slider->importSliderFromPost(true,true,$filepath);  
           }
       
           echo ' Slider processed';
        }
        
        if ( 'Import Construction' === $selected_import['import_file_name'] ) { 
            // Assign front page and posts page (blog page).
            $front_page_id = get_page_by_title( 'Home 6' );
            update_option( 'netfx_on_front', 'page' );
            update_option( 'page_on_front', $front_page_id->ID );
        }else {
            // Assign front page and posts page (blog page).
            $front_page_id = get_page_by_title( 'Home' );
            update_option( 'netfx_on_front', 'page' );
            update_option( 'page_on_front', $front_page_id->ID );
        }
    
        
    }
    add_action( 'pt-ocdi/after_import', 'jws_after_import' );
endif;


function jws_scripts_plugin() {
    /**
     * Enqueue scripts and styles for the front end.
     */
    wp_localize_script('jquery', 'Verify_Ajax', array(
        'metera'  =>  esc_html__('Very weak','ailab'),
        'meterb'  =>  esc_html__('Weak','ailab'),
        'meterc'  =>  esc_html__('Medium','ailab'),
        'meterd'  =>  esc_html__('Strong','ailab'),
        )
    );
}
add_action( 'wp_enqueue_scripts', 'jws_scripts_plugin' ); 


/** Disable All WooCommerce  Styles and Scripts Except Shop Pages*/
add_action( 'wp_enqueue_scripts', 'dequeue_woocommerce_styles_scripts', 99 );
function dequeue_woocommerce_styles_scripts() {
if ( function_exists( 'is_woocommerce' ) ) {
if ( ! is_woocommerce() && ! is_cart() && ! is_checkout() ) {
# Styles
wp_deregister_script('jquery-plugin');
wp_deregister_script('jquery-countdown');
wp_dequeue_style( 'woocommerce-general' );
wp_dequeue_style( 'woocommerce-layout' );
wp_dequeue_style( 'woocommerce-smallscreen' );
wp_dequeue_style( 'woocommerce_frontend_styles' );
wp_dequeue_style( 'woocommerce_fancybox_styles' );
wp_dequeue_style( 'woocommerce_chosen_styles' );
wp_dequeue_style( 'woocommerce_prettyPhoto_css' );
# Scripts
wp_dequeue_script( 'wc_price_slider' );
wp_dequeue_script( 'wc-single-product' );
wp_dequeue_script( 'wc-checkout' );
wp_dequeue_script( 'wc-single-product' );
wp_dequeue_script( 'wc-chosen' );
wp_dequeue_script( 'woocommerce' );
wp_dequeue_script( 'prettyPhoto' );
wp_dequeue_script( 'prettyPhoto-init' );
wp_dequeue_script( 'jquery-blockui' );
wp_dequeue_script( 'jquery-placeholder' );
wp_dequeue_script( 'fancybox' );
wp_dequeue_script( 'jqueryui' );
}
}
}