<?php
/**
 * The template for displaying 404 pages (not found)
 *
 * @link https://codex.wordpress.org/Creating_an_Error_404_Page
 *
 * @package WordPress
 * @subpackage netfx
 * @since 1.0.0
 */
global $jws_option;
$pagetitle = (isset($jws_option['title_404']) && $jws_option['title_404']) ? $jws_option['title_404']:'404';
$button_link = (isset($jws_option['button_link_404']) && $jws_option['button_link_404']) ? $jws_option['button_link_404']:get_home_url();
get_header();
if((isset($jws_option['404-title-bar-switch']) && $jws_option['404-title-bar-switch']) || !isset($jws_option['404-title-bar-switch'] )) {
    jws_title_bar();  
} 
?>
	<section id="primary" class="content-area">
		<main id="main" class="site-main">
            
			<div class="error-404 not-found">
                <div class="container">
                    <div class="row">
                        <div class="text-404 col-xl-5 col-lg-5 col-md-12">
        					<h1 class="page-title"><span class="first-text"></span><span class="second-text"><?php echo esc_html($pagetitle); ?></span></h1>
                            
        				</div><!-- .page-header -->
        
        				<div class="404-content col-xl-5 col-lg-5 col-md-12 page-content">
                            <h2><?php echo esc_html__('Oops...','netfx'); ?></h2>
        					<p class="content"><?php if(isset($jws_option['content_404']) && $jws_option['content_404']) {
                                    
                                    echo esc_html($jws_option['content_404']);
                                    
                                }else {
                                    
                                    echo esc_html__('Oops! The page you are looking for does not exist. It might have been moved or deleted.','netfx');
                                    
                                } ?><</p>
                            
                       	    <a href="<?php echo esc_url($button_link); ?>" class="bt-home btn-button btn-primary">
                                <span><?php if(isset($jws_option['button_text_404']) && $jws_option['button_text_404']) {
                                    
                                    echo esc_html($jws_option['button_text_404']);
                                    
                                }else {
                                    
                                    echo esc_html__('Back to home','netfx');
                                    
                                } ?></span>  
                            </a>
                            
        				
        				</div><!-- .page-content -->
                    </div>
                </div>
				
			</div><!-- .error-404 -->

		</main><!-- #main -->
	</section><!-- #primary -->


	</div><!-- #content -->
</div><!-- #page -->

<?php get_footer(); ?>

</body>
</html>

