<?php
/**
 * The template for displaying archive pages
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/
 *
 * @package WordPress
 * @subpackage netfx
 * @since 1.0.0
 */

get_header();
global $jws_option;

if((isset($jws_option['show_position_sidebar']) && $jws_option['show_position_sidebar'] == 'no_sidebar') || ((did_action( 'elementor/loaded' )) && \Elementor\Plugin::$instance->editor->is_edit_mode() )) {
   $content_col = ' col-12 jws-show-element'; 
   $sidebar_col = 'postt_sidebar main-sidebar';
   $class = ' no_sidebar';
}else {
   $content_col = 'post_content col-xl-9 col-lg-8 col-12 jws-show-element';
   $sidebar_col = 'post_sidebar main-sidebar col-xl-3 col-lg-4 col-12'; 
   $class = ' has_sidebar'; 
}

        if(isset($jws_option['shows-title-bar-switch']) && $jws_option['shows-title-bar-switch']) {
          if (isset($jws_option['select-titlebar-shows']) && !empty($jws_option['select-titlebar-shows'])) { ?>
             <div class="jws-title-bar">
        
               <?php  echo do_shortcode('[hf_template id="' . $jws_option['select-titlebar-shows'] . '"]'); ?>
            </div>
        <?php }else {
             jws_title_bar();  
        }
        } 
  
     $layout = (isset($jws_option['shows_layout']) && !empty($jws_option['shows_layout'])) ? $jws_option['shows_layout'] : 'layout3';
     
     $class_row = 'row show-content';  
      $class_row .= ' jws_show_'.$layout.'';
     
      $class_row.= ' jws-isotope'; 
    
      
      $class_column = 'jws-show-item';
      if($jws_option['show_display'] != 'slider') { 
           $class_column .= ' col-xl-'.$jws_option['show_columns'].'';
          $class_column .= (!empty($jws_option['show_columns_tablet'])) ? ' col-lg-'.$jws_option['show_columns_tablet'].'' : ' col-lg-'.$jws_option['show_columns'].'' ;
          $class_column .= (!empty($jws_option['show_columns_mobile'])) ? ' col-'.$jws_option['show_columns_mobile'].'' :  ' col-'.$jws_option['show_columns'].'';
      }
 
      
      if($jws_option['show_display'] == 'slider') {
            $class_row .= ' jws_show_'.$jws_option['show_display'].'';
            $class_row .= ' ' . $jws_option['arrow_position'];
            $dots = ($jws_option['navigation'] == 'dots' || $jws_option['navigation'] == 'both') ? 'true' : 'false';
            $arrows = ($jws_option['navigation'] == 'arrows' || $jws_option['navigation'] == 'both') ? 'true' : 'false';
            $autoplay = ($jws_option['autoplay'] == 'yes') ? 'true' : 'false';
            $pause_on_hover = ($jws_option['pause_on_hover'] == 'yes') ? 'true' : 'false';
            $infinite = ($jws_option['infinite'] == 'yes') ? 'true' : 'false';
            $rtl = ($jws_option['rtl'] == 'yes') ? 'true' : 'false';
            
            $autoplay_speed = ($jws_option['autoplay_speed']) ? $jws_option['autoplay_speed'] : '0';
            $data_slick = 'data-slick=\'{"slidesToShow":'.$jws_option['slides_to_show'].' ,"slidesToScroll": '.$jws_option['slides_to_scroll'].',"rtl":'.$rtl.', "autoplay": '.$autoplay.',"arrows": '.$arrows.', "dots":'.$dots.', "autoplaySpeed": '.$autoplay_speed.',"pauseOnHover":'.$pause_on_hover.',"infinite":'.$infinite.',
            "speed": '.$jws_option['transition_speed'].', "responsive":[{"breakpoint": 1024,"settings":{"slidesToShow": '.$jws_option['slides_to_show_tablet'].',"slidesToScroll": '.$jws_option['slides_to_scroll_tablet'].'}},
            {"breakpoint": 768,"settings":{"slidesToShow": '.$jws_option['slides_to_show_mobile'].',"slidesToScroll": '.$jws_option['slides_to_scroll_mobile'].'}}]}\''; 
       }else {
            $data_slick = '';
             
       }
       if($jws_option['enable_masonry'] == 'yes') {
            $class_row .= ' has-masonry';
       }
       
       if($jws_option['enable_animation'] == 'yes') {
            $class_row .= ' has-animation';
            $class_column .= ' jws-ani-item';
       }
        $order=1;
?>
<div id="primary" class="content-area">
		<main id="main" class="site-main">
        <div class="container">
        <div class="row">
             <?php if(isset($jws_option['show_position_sidebar']) && $jws_option['show_position_sidebar'] == 'left') : ?>
                <div class="<?php echo esc_attr($sidebar_col); ?>">
                    <div class="jws_show_sidebar">
                        	<?php
                                if (isset($jws_option['select-sidebar-show']) && !empty($jws_option['select-sidebar-show'])) { 
                                             echo do_shortcode('[hf_template id="' . $jws_option['select-sidebar-show'] . '"]'); 
                                }else {
                                   if ( is_active_sidebar( 'show-sidebar' ) ) {
                        			     dynamic_sidebar( '<strong>show-sidebar</strong>' );
                        		   } 
                                }	
    		                 ?>
                    </div>
                </div>
            <?php endif; ?> 
            <div class="<?php echo esc_attr($content_col); ?>">
                <div class="<?php echo esc_attr($class_row); ?>" <?php echo wp_kses_post($data_slick); ?>>
                	<?php if ( have_posts() ) :
            			while ( have_posts() ) :
            				the_post();
                            $format = has_post_format() ? get_post_format() : 'no_format';  
            				/*
            				 * Include the Post-Format-specific template for the content.
            				 * If you want to override this in a child theme, then include a file
            				 * called content-___.php (where ___ is the Post Format name) and that will be used instead.
            				 */
                             echo '<article class="'.$class_column.' '.$format.'">';
                             include( 'template-parts/content/shows/archive-layout/' . $layout . '.php'); ?>
                              
                            </article>
            
            				
            			<?php
                        // End the loop.
                         endwhile;
            
            
            			// If no content, include the "No posts found" template.
            		else :
            			get_template_part( 'template-parts/content/content', 'none' );
            
            		endif;
            		?>
                    </div> 
                    <?php global $wp_query;   echo jws_query_pagination($wp_query); ?>
            </div>
            <?php if((isset($jws_option['position_sidebar']) && $jws_option['position_sidebar'] == 'right')) : ?>
                <div class="<?php echo esc_attr($sidebar_col); ?>">
                    <div class="jws_show_sidebar">
                        	<?php
                                if (isset($jws_option['select-sidebar-pshowost']) && !empty($jws_option['select-sidebar-show'])) { 
                                             echo do_shortcode('[hf_template id="' . $jws_option['select-sidebar-show'] . '"]'); 
                                }else {
                                   if ( is_active_sidebar( 'show-sidebar' ) ) {
                        			     dynamic_sidebar( 'show-sidebar' );
                        		   } 
                                }	
    		                 ?>
                    </div>
                </div>
            <?php endif; ?>    
        </div>
	
        </div>
		</main><!-- #main -->
	</div><!-- #primary -->

<?php
get_footer();
