<?php
if (post_password_required()) {
	return;
}
?>
<div class="comment-section">
<div id="comments" class="comments-area">
	<?php // You can start editing here -- including this comment! ?>
	<?php if (have_comments()) : ?>
		<div class="comment_top">
			<?php $comments_number = get_comments_number(); ?>
			<h3 class="comments-title">
				<?php
					echo esc_html__('Comments', 'netfx');
				?>
			</h3>
		
		<ol class="comment-list">
			<?php
			wp_list_comments(array(
				'style' => 'ol',
				'short_ping' => true,
				'avatar_size' => 110,
				'callback' => 'jws_custom_comment',
				'reply_text' => 'Reply',
				));
				?>
			</ol><!-- .comment-list -->
        <?php
		the_comments_pagination(
			array(
				'before_page_number' => esc_html__( 'Page', 'netfx' ) . ' ',
				'mid_size'           => 0,
				'prev_text'          => sprintf(
					'%s <span class="nav-prev-text">%s</span>',
					'',
					esc_html__( 'Older comments', 'netfx' )
				),
				'next_text'          => sprintf(
					'<span class="nav-next-text">%s</span> %s',
					esc_html__( 'Newer comments', 'netfx' ),
					''
				),
			)
		);
		?>
		</div>
	<?php endif; // have_comments() ?>
	<?php
    // If comments are closed and there are comments, let's leave a little note, shall we?
	if (!comments_open() && '0' != get_comments_number() && post_type_supports(get_post_type(), 'comments')) :
		?>
	<p class="no-comments"><?php esc_html_e('Comments are closed.', 'netfx'); ?></p>
<?php endif; ?>
<?php
$commenter = wp_get_current_commenter();

$fields = array(
    'alert' =>
	'<p class="comment-form-alert">'.wp_kses('Your email address will not be published. Required fields are marked *', 'netfx').'</p>',
	'author' =>
	'<div class="row input-items"><p class="comment-form-author col-xl-6 col-md-6 col-12 form-control"><label>'.esc_html__("Name","netfx").' <code>*</code></label><span><input id="author" text name="author" type="text" value="' . esc_attr($commenter['comment_author']) . '" size="30" aria-required="true" /></span></p>',
	'email' =>
	'<p class="comment-form-email col-xl-6 col-md-6 col-12 form-control"><label>'.esc_html__("Email","netfx").' <code>*</code></label><span><input id="email" name="email"  type="email" value="' . esc_attr($commenter['comment_author_email']) . '" size="30" aria-required="true" /></p></span></div>',
    
    );
$args = array(
	'id_form' => 'commentform',
	'id_submit' => 'submit',
	'class_submit' => 'submit ',
	'name_submit' => 'submit',
	'title_reply' => esc_html__('Post A Comment', 'netfx'),
	'title_reply_to' => esc_html__('Leave A Reply  %s', 'netfx'),
	'cancel_reply_link' => esc_html__('', 'netfx'),
	'label_submit' => esc_html__('Submit', 'netfx'),
	'format' => 'xhtml',
	'fields' => apply_filters('comment_form_default_fields', $fields),
	'must_log_in' => '<p class="must-log-in">' .
	sprintf(
		wp_kses('You must be <a href="%s">logged in</a> to post a comment.', 'netfx'),
		wp_login_url(apply_filters('the_permalink', get_permalink()))
		) . '</p>',
	'logged_in_as' => '<p class="logged-in-as">' .
	sprintf(
		wp_kses('Logged in as <a href="%1$s">%2$s</a>. <a href="%3$s" title="' . esc_attr('Log out of this account') . '">Log out?</a>', 'netfx'),
		admin_url('profile.php'),
		$user_identity,
		wp_logout_url(apply_filters('the_permalink', get_permalink()))
		) . '</p>',
	'comment_notes_before' => '',
	'comment_notes_after' => '',
	'comment_field' => '<p class="comment-form-comment2 form-control"><label>'.esc_html__("Your comment...","netfx").'</label><span><textarea id="comment" name="comment" cols="60" rows="6" aria-required="true" >' . '</textarea></span></p>',
	);
comment_form($args);
?>
</div><!-- #comments -->
</div>
