<?php
require_once('cmb2-field-map.php'); 
/**
 * Define the metabox and field configurations.
 */
function cmb2_sample_metaboxes() {
	/**
	 * Initiate the metabox
	 */
     //For Team
     $cmb = new_cmb2_box( array(
		'id'            => 'teams_metabox',
		'title' => esc_html__( 'Teams Setting', 'netfx' ),
			'object_types' => array('teams'), // post type
			'context' => 'normal',
			'priority' => 'high',
			'show_names' => true, // Show field names on the left
			) );
   $cmb->add_field( array(
	'name'    => 'Position',
	'desc'    => 'Position',
	'default' => 'SEO',
	'id'      => 'postion',
	'type'    => 'text',
    ) );
   $cmb->add_field( array(
	'name'    => 'Email Address',
	'desc'    => 'Email',
	'default' => 'abc@gmail.com',
	'id'      => 'email_address',
	'type'    => 'text',
    ) );
        
    $cmb->add_field( array(
	'name'    => 'Number Phone',
	'desc'    => 'Number Phone',
	'default' => '123 2323 3232',
	'id'      => 'number_phone',
	'type'    => 'text',
    ) );
    $group_field_id = $cmb->add_field( array(
        'id'          => 'social_media',
        'type'        => 'group',
        'description' => esc_html__( 'Social Media', 'netfx' ),
        // 'repeatable'  => false, // use false if you want non-repeatable group
        'options'     => array(
            'group_title'       => esc_html__( 'Info {#}', 'netfx' ), // since version 1.1.4, {#} gets replaced by row number
            'add_button'        => esc_html__( 'Add More Social Media', 'netfx' ),
            'remove_button'     => esc_html__( 'Remove Social Media', 'netfx' ),
            'sortable'          => true,
            // 'closed'         => true, // true to have the groups closed by default
            // 'remove_confirm' => esc_html__( 'Are you sure you want to remove?', 'netfx' ), // Performs confirmation before removing group.
            ),
        ) );
     $cmb->add_group_field( $group_field_id, array(
    	'name'    => 'Social Media Name',
    	'desc'    => 'Social Media Name',
        'default' =>
                'Facebook',
    
    	'id'      => 'social_media_name',
    	'type'    => 'text',
    ) );
    $cmb->add_group_field( $group_field_id, array(
	'name'    => 'Icon',
	'desc'    => 'Input social media icon',
    'default' =>
            'fab fa-facebook-f',

	'id'      => 'social_media_icon_name',
	'type'    => 'text',
) );
    $cmb->add_group_field( $group_field_id, array(
        'name' => 'Link',
        'id'   => 'social_media_link',
        'default' =>
            'https://facebook.com',
           
        'type' => 'text',
        ) );
    
    // For agency
    $cmb = new_cmb2_box( array(
		'id'            => 'agencies_metabox',
		'title'         => esc_html__( 'Agencies Setting', 'netfx' ),
		'object_types'  => array('agencies'), // Post type
		'context' => 'normal',
		'priority' => 'high',
		'show_names' => true, // Show field names on the left
		) );
  $cmb->add_field( array(
	'name' => 'Location',
	'desc' => '',
	'id' => 'agencies_location',
	'type' => 'pw_map',
	// 'split_values' => true, // Save latitude and longitude as two separate fields
) );
    
     // For Service
	$cmb = new_cmb2_box( array(
		'id'            => 'services_metabox',
		'title'         => esc_html__( 'Services Setting', 'netfx' ),
		'object_types'  => array('services'), // Post type
		'context' => 'normal',
		'priority' => 'high',
		'show_names' => true, // Show field names on the left
		) );
        $cmb->add_field( array(
              'name'    => 'Service Icon',
              'desc'    => 'Upload icon by svg, png/jpg file)',
              'id'      => 'service_icon',
              'type'    => 'file',
              // Optional:
              'options' => array(
                'url' => false, // Hide the text input for the url
              ),
              'text'    => array(
                'add_upload_file_text' => 'Add Icon' // Change upload button text. Default: "Add or Upload File"
              ),
              // query_args are passed to wp.media's library query.
              'query_args'   => array(
                'type' => array(
                    'image/svg',
                ),
            ),
              'preview_size' => 'large', // Image size to use when previewing in the admin.
            ) );
    // For Product
	$cmb = new_cmb2_box( array(
		'id'            => 'product_metabox',
		'title'         => esc_html__( 'Product Setting', 'netfx' ),
		'object_types'  => array('product'), // Post type
		'context' => 'normal',
		'priority' => 'high',
		'show_names' => true, // Show field names on the left
		) );
	$cmb->add_field( array(
    	'name' => 'Enable Large Thumbnail (Apply for Product Layout Metro only)',
    	'id'   => 'wc-thumbnail-size',
    	'type' => 'checkbox',
    ) ); 
    $cmb->add_field( array(
    	'name' => 'Enable New Label',
    	'id'   => 'jws_new_label',
    	'type' => 'checkbox',
    ) ); 
    // For Product
	$cmb = new_cmb2_box( array(
		'id'            => 'product_tab_metabox',
		'title'         => esc_html__( 'Product Tab', 'netfx' ),
		'object_types'  => array('product'), // Post type
		'context' => 'normal',
		'priority' => 'high',
		'show_names' => true, // Show field names on the left
		) );
	$cmb->add_field( array(
    	'name' => 'Ingredient Tab',
    	'id'   => 'ingredient',
    	'type' => 'wysiwyg',
    ) );
    $cmb->add_field( array(
    	'name' => 'Guide Tab',
    	'id'   => 'guide',
    	'type' => 'wysiwyg',
    ) ); 
    $cmb->add_field( array(
    	'name' => 'Delivery & Returns',
    	'id'   => 'shipping',
    	'type' => 'wysiwyg',
    ) );  
         // For Product
	$cmb = new_cmb2_box( array(
		'id'            => 'product_layout_metabox',
		'title'         => esc_html__( 'Product Layout', 'netfx' ),
		'object_types'  => array('product'), // Post type
		'context' => 'normal',
		'priority' => 'high',
		'show_names' => true, // Show field names on the left
		) );
   // $cmb->add_field( array(
    //	'name' => 'Enable Hero Slider',
    //	'id'   => 'hero_slider',
    //	'type' => 'checkbox',
//	) );   
	$cmb->add_field( array(
    	'name' => 'Style Product Detail Layout',
    	'id'   => 'single-layout',
        'type' => 'select',
        'default'          => 'layout1',
        'options'          => array(
            'layout1' => esc_html__( 'Layout 1', 'netfx' ),
            'layout2'   => esc_html__( 'Layout 2', 'netfx' ),
            'layout3'     => esc_html__( 'Layout 3', 'netfx' ),
            'layout4'   => esc_html__( 'Layout 4', 'netfx' ),
            'layout5'     => esc_html__( 'Layout 5', 'netfx' ),
        ),
    ) ); 
    $cmb->add_field( array(
    	'name' => 'Entry Summary Content',
    	'id'   => 'entry_column',
        'type' => 'select',
        'default'          => '0',
        'options'          => array(
            '0' => esc_html__('Globle Column', 'netfx'),
            '5' => esc_html__( '5/12', 'netfx' ),
            '7'   => esc_html__( '7/12', 'netfx' ),
            '4'     => esc_html__( '4/12', 'netfx' ),
            '6'   => esc_html__( '6/12', 'netfx' ),
            '3'     => esc_html__( '1/12', 'netfx' ),
        ),
    ) ); 
	$cmb->add_field( array(
    	'name' => 'Thubmnail Position apply for product layout 1',
    	'id'   => 'thumbnail_position',
        'type' => 'select',
        'default'          => 'layout1',
        'options'          => array(
            'left' => esc_html__( 'Left', 'netfx' ),
            'right'   => esc_html__( 'Right', 'netfx' ),
            'bottom'     => esc_html__( 'Bottom', 'netfx' ),
        ),
    ) );
    $cmb->add_field( array(
    	'name' => 'Show Recently Product Viewed',
    	'id'   => 'show_recently_product_viewed',
    	'type' => 'checkbox',
	) );  
    // For shows
    $cmb = new_cmb2_box( array(
		'id'            => 'shows_metabox',
		'title'         => esc_html__( 'shows Setting', 'netfx' ),
		'object_types'  => array('shows'), // Post type
		'context' => 'normal',
		'priority' => 'high',
		'show_names' => true, // Show field names on the left
		) );
  $cmb->add_field( array(
    	'name' => 'Year',
    	'id'   => 'year',
    	'type' => 'text',
        'default' => '2013',
    ) ); 
     $cmb->add_field( array(
    	'name' => 'Time',
    	'id'   => 'time',
    	'type' => 'text',
        'default' => '1 hr 26 min',
    ) ); 
    $cmb->add_field( array(
    	'name' => 'Starring',
    	'id'   => 'starring',
    	'type' => 'text',
        'default' => 'Tamika Shannon, Stephen Green, Nijah Brenea',
    ) ); 
    $cmb->add_field( array(
    	'name' => 'Director',
    	'id'   => 'director',
    	'type' => 'text',
        'default' => 'John Henry',
    ) ); 
    $cmb->add_field( array(
    	'name' => 'Imdb',
    	'id'   => 'imdb',
    	'type' => 'text',
        'default' => '8.9',
    ) ); 
      $cmb->add_field( array(
        'name'    => 'Detail & Info',
    	'id'      => 'info',
    	'type'    => 'wysiwyg',
    	'options' => array(),
    ) );
    $cmb->add_field( array(
    	'name' => 'Label',
    	'id'   => 'label',
    	'type' => 'text',
        'default' => 'Live',
    ) ); 
      $cmb->add_field( array(
    	'name' => 'Gallery',
    	'desc' => '',
    	'id'   => 'show_gallery',
    	'type' => 'file_list',
    	// 'preview_size' => array( 100, 100 ), // Default: array( 50, 50 )
    	// 'query_args' => array( 'type' => 'image' ), // Only images attachment
    	// Optional, override default text strings
    	'text' => array(
    		'add_upload_files_text' => 'Add or Upload', // default: "Add or Upload Files"
    		'remove_image_text' => 'Replacement', // default: "Remove Image"
    		'file_text' => 'File:', // default: "File:"
    		'file_download_text' => 'Download', // default: "Download"
    		'remove_text' => 'Remove', // default: "Remove"
    	),
    ) );
      $cmb->add_field( array(
    	'name' => 'News',
    	'id'   => 'show_news',
    	'type' => 'checkbox',
    ) );  
      $cmb->add_field( array(
    	'name' => 'TV',
    	'id'   => 'show_tv',
    	'type' => 'checkbox',
    ) );
     $cmb->add_field( array(
    	'name' => 'Video Link',
    	'id'   => 'show_video_link',
    	'type' => 'text',
        'default' => 'https://youtube.com',
    ) ); 
    $cmb->add_field( array(
    	'name' => 'Ticket Link',
    	'id'   => 'show_ticket_link',
    	'type' => 'text',
        'default' => 'https://youtube.com',
    ) ); 
      // For Shows Video
	$cmb = new_cmb2_box( array(
		'id'            => 'show_video_metabox',
		'title'         => esc_html__( 'Show Video Setting', 'netfx' ),
		'object_types'  => array('shows'), // Post type
		'context' => 'normal',
		'priority' => 'high',
		'show_names' => true, // Show field names on the left
         'show_on'      => array( 'key' => 'post_format', 'value' => 'video' ),
		) );
	$cmb->add_field( array(
    	'name' => 'Add Url For Video',
    	'desc' => 'show video when lick',
    	'id'   => 'show_video',
    	'type' => 'text',
    ) );
    $cmb->add_field( array(
    	'name' => 'Add Caption For video',
    	'id' => 'show_video_caption',
    	'type' => 'textarea'
    ) );
    $cmb->add_field( array(
    	'name' => 'Add Embed For Single',
    	'id' => 'show_video_url_embed',
    	'type' => 'textarea'
    ) );
     $cmb->add_field( array(
		'name'    => 'Video Image',
		'id'      => 'shows_image_video',
		'type'    => 'file',
		'default' => '',
		'text'    => array(
		'add_upload_file_text' => 'Upload File' // Change upload button text. Default: "Add or Upload File"
    	),
    	// query_args are passed to wp.media's library query.
    	'query_args' => array(
            'type' => array(
    		 	'image/gif',
    		 	'image/jpeg',
    		 	'image/png',
    		 ),
    	),
    	'preview_size' => 'large', // Image size to use when previewing in the admin.
            
		) );
     // For Blog Video
     	$cmb = new_cmb2_box( array(
		'id'            => 'blog_time_read',
		'title'         => esc_html__( 'Time to read Setting', 'netfx' ),
		'object_types'  => array('post'), // Post type
		'context' => 'normal',
		'priority' => 'high',
		'show_names' => true, // Show field names on the left
         'show_on'      => array( 'key' => 'post_format', 'value' => 'video' ),
		) );
	$cmb->add_field( array(
    	'name' => 'Time to read blog',
    	'desc' => 'Time to read blog',
    	'id'   => 'blog_time',
    	'type' => 'text',
    ) );
	$cmb = new_cmb2_box( array(
		'id'            => 'blog_video_metabox',
		'title'         => esc_html__( 'Blog Video Setting', 'netfx' ),
		'object_types'  => array('post'), // Post type
		'context' => 'normal',
		'priority' => 'high',
		'show_names' => true, // Show field names on the left
         'show_on'      => array( 'key' => 'post_format', 'value' => 'video' ),
		) );
	$cmb->add_field( array(
    	'name' => 'Add Url For Video',
    	'desc' => 'show video when lick',
    	'id'   => 'blog_video',
    	'type' => 'text',
    ) );
    $cmb->add_field( array(
    	'name' => 'Add Caption For video',
    	'id' => 'video_caption',
    	'type' => 'textarea'
    ) );
    $cmb->add_field( array(
    	'name' => 'Add Embed For Single',
    	'id' => 'video_url_embed',
    	'type' => 'textarea'
    ) );
       // For Blog quote
	$cmb = new_cmb2_box( array(
		'id'            => 'blog_quote_metabox',
		'title'         => esc_html__( 'Blog quote Setting', 'netfx' ),
		'object_types'  => array('post'), // Post type
		'context' => 'normal',
		'priority' => 'high',
		'show_names' => true, // Show field names on the left
         'show_on'      => array( 'key' => 'post_format', 'value' => 'quote' ),
		) );
	$cmb->add_field( array(
    	'name' => 'Add Name Quote',
    	'id'   => 'blog_name_quote',
    	'type' => 'text',
    ) );
    $cmb->add_field( array(
    	'name' => 'Add Description Quote',
    	'id' => 'blog_description_quote',
    	'type' => 'textarea'
    ) );
   // For Blog Link
	$cmb = new_cmb2_box( array(
		'id'            => 'blog_link_metabox',
		'title'         => esc_html__( 'Blog Link Setting', 'netfx' ),
		'object_types'  => array('post'), // Post type
		'context' => 'normal',
		'priority' => 'high',
		'show_names' => true, // Show field names on the left
         'show_on'      => array( 'key' => 'post_format', 'value' => 'link' ),
		) );
	$cmb->add_field( array(
    	'name' => 'Add Name Link',
    	'id'   => 'blog_name_link',
    	'type' => 'text',
    ) );
    $cmb->add_field( array(
    	'name' => 'Add Url Link',
    	'id'   => 'blog_url_link',
    	'type' => 'text',
    ) );
    // For Blog Audio
	$cmb = new_cmb2_box( array(
		'id'            => 'blog_audio_metabox',
		'title'         => esc_html__( 'Blog Audio Setting', 'netfx' ),
		'object_types'  => array('post'), // Post type
		'context' => 'normal',
		'priority' => 'high',
		'show_names' => true, // Show field names on the left
         'show_on'      => array( 'key' => 'post_format', 'value' => 'audio' ),
		) );
  $cmb->add_field( array(
        'name'             => 'Radio Media',
        'id'               => 'blog_media_radio',
        'type'             => 'file',
    ) );
	$cmb->add_field( array(
    	'name' => 'Add Url Embed',
    	'id' => 'audio_url_embed',
        'desc' => 'show icon to services widget elementor',
    	'type' => 'textarea'
    ) );
    // For Blog Galley
	$cmb = new_cmb2_box( array(
		'id'            => 'blog_gallery_metabox',
		'title'         => esc_html__( 'Blog Gallery Setting', 'netfx' ),
		'object_types'  => array('post'), // Post type
		'context' => 'normal',
		'priority' => 'high',
		'show_names' => true, // Show field names on the left
         'show_on'      => array( 'key' => 'post_format', 'value' => 'gallery' ),
		) );
    $cmb->add_field( array(
	'name' => 'Image List',
	'desc' => '',
	'id'   => 'image_gallery_list',
	'type' => 'file_list',
	// 'preview_size' => array( 100, 100 ), // Default: array( 50, 50 )
	// 'query_args' => array( 'type' => 'image' ), // Only images attachment
	// Optional, override default text strings
	'text' => array(
		'add_upload_files_text' => esc_html__( 'Add Image', 'netfx' ), // default: "Add or Upload Files"
		'remove_image_text' => esc_html__( 'Remove Image', 'netfx' ), // default: "Remove Image"

	),
    ) );
    // For Page
    $cmb = new_cmb2_box( array(
		'id'            => 'page_metabox',
		'title'         => esc_html__( 'Page Setting', 'netfx' ),
		'object_types'  => array('page','shows'), // Post type
		'context' => 'normal',
		'priority' => 'high',
		'show_names' => true, // Show field names on the left
	) );

    $cmb->add_field( array(
    	'name' => 'Enable Title Bar',
    	'id'   => 'title_bar_checkbox',
    	'type' => 'checkbox',
    ) );   
     $cmb->add_field( array(
    	'name' => 'Enable Title Bar',
    	'id'   => 'title_bar_checkbox',
    	'type' => 'checkbox',
	) );    
    $cmb->add_field( array(
    	'name' => 'Title Bar Type',
    	'id'   => 'titlebar-type',
        'type' => 'select',
        'default'          => 'global',
        'options'          => array(
            'global' => esc_html__( 'Global', 'netfx' ),
            'type1' => esc_html__( 'Standard', 'netfx' ),
            'type2'   => esc_html__( 'Title Left and Breakscumb Right', 'netfx' ),
        ),
    ) );
    $cmb->add_field( array(
    	'name' => 'Switch On breadcrumbs',
    	'id'   => 'titlebar-breadcrumbs',
        'type' => 'select',
        'default'          => 'global',
        'options'          => array(
            'global' => esc_html__( 'Global', 'netfx' ),
            'type1' => esc_html__( 'On', 'netfx' ),
            'type2'   => esc_html__( 'Off', 'netfx' ),
        ),
    ) );  
    $cmb->add_field( array(
    	'name' => 'Sub Title',
    	'id'   => 'sub_titlebar',
    	'type' => 'text',
    ) );
    $cmb->add_field( array(
		'name'    => 'Title Bar image',
		'id'      => 'title_bar_image',
		'type'    => 'file',
		'default' => '',
		'text'    => array(
		'add_upload_file_text' => 'Upload File' // Change upload button text. Default: "Add or Upload File"
    	),
    	// query_args are passed to wp.media's library query.
    	'query_args' => array(
            'type' => array(
    		 	'image/gif',
    		 	'image/jpeg',
    		 	'image/png',
    		 ),
    	),
    	'preview_size' => 'large', // Image size to use when previewing in the admin.
            
		) );
        $cmb->add_field( array(
    	'name' => 'Title Bar Text Align',
    	'id'   => 'title_bar_text_align',
        'type' => 'select',
        'default'          => 'center',
        'options'          => array(
            'left' => esc_html__( 'Left', 'netfx' ),
            'right'   => esc_html__( 'Right', 'netfx' ),
            'center'     => esc_html__( 'Center', 'netfx' ),
        ),
    ) );
	$cmb->add_field( array(
		'name'    => 'Custom Main Color',
		'id'      => 'custom_main_color',
		'type'    => 'colorpicker',
		'default' => '',
		'options' => array(
			'color' => false,
			),
		) );
	$args = array('post_type' => 'hf_template', 'posts_per_page' => -1);
	$loop = new WP_Query($args);
	if($loop->have_posts()) {  
		while($loop->have_posts()) : $loop->the_post();
			//
			$varID = get_the_id();
			$varName = get_the_title();
			$pageArray[$varID]=$varName;
		endwhile;
		wp_reset_postdata();   
	}else {
		$pageArray['null']=''; 
	}
	$cmb->add_field( array(
		'name'             => 'Select Header For Page',
		'id'               => 'page_select_header',
		'type'             => 'select',
		'show_option_none' => true,
		'options' => $pageArray
	) );
    $cmb->add_field( array(
    'name' => 'Disable Header',
    'desc' => 'Turn on this option to disable the header on your page',
    'id'   => 'disable_header',
    'type' => 'checkbox',
    ) );
      $cmb->add_field( array(
    	'name' => 'Switch On Header Top Bar',
    	'id'   => 'header-top-bar',
        'type' => 'select',
        'default'          => 'global',
        'options'          => array(
            'global' => esc_html__( 'Global', 'netfx' ),
            'on' => esc_html__( 'On', 'netfx' ),
            'off'   => esc_html__( 'Off', 'netfx' ),
        ),
    ) ); 
 
    $cmb->add_field( array(
    	'name' => 'Header Absolute',
    	'id'   => 'page_header_absolute',
        'type' => 'select',
        'default'          => 'global',
        'options'          => array(
            'global' => esc_html__( 'Global', 'netfx' ),
            'on' => esc_html__( 'On', 'netfx' ),
            'off'   => esc_html__( 'Off', 'netfx' ),
        ),
    ) ); 
	$cmb->add_field( array(
		'name'             => 'Select Footer For Page',
		'id'               => 'page_select_footer',
		'type'             => 'select',
		'show_option_none' => true,
		'options' => $pageArray
	) );
    $cmb->add_field( array(
    'name' => 'Disable Footer',
    'desc' => 'Turn on this option to disable the footer on your page',
    'id'   => 'disable_footer',
    'type' => 'checkbox',
    ) );

}
add_action( 'cmb2_admin_init', 'cmb2_sample_metaboxes' );

if ( ! function_exists( 'jws_cmb2_script' ) ) :
	function jws_cmb2_script() {
        wp_enqueue_style( 'cmb2-map', JWS_URI_PATH . '/inc/admin/cmb2/css/style.css', wp_get_theme()->get( 'Version' ), 'all' );
	}
add_action( 'admin_enqueue_scripts', 'jws_cmb2_script' );
endif;


function yourprefix_register_taxonomy_metabox() {
    $prefix = 'shows_channel_';
    /**
     * Metabox to add fields to categories and tags
     */
    $cmb_term = new_cmb2_box (array(
        'id'               => $prefix . 'edit',
        'title'            => esc_html__( 'Category Metabox', 'netfx' ), // Doesn't output for term boxes
        'object_types'     => array( 'term' ), // Tells CMB2 to use term_meta vs post_meta
        'taxonomies'       => 'shows_channel' , // Tells CMB2 which taxonomies should have these fields
        // 'new_term_section' => true, // Will display in the "Add New Category" section
    ) );
    $cmb_term->add_field( array(
        'name' => esc_html__( 'Channel_image', 'netfx' ),
        'desc' => esc_html__( 'field description (optional)', 'netfx' ),
        'id'   => $prefix . 'channel_image',
        'type' => 'file',
	) );
}
add_action( 'cmb2_admin_init', 'yourprefix_register_taxonomy_metabox' );