<?php 

function check_km_location($origin,$destination) {
   global $jws_option; 

  
   if(isset($destination) && empty($destination)) {
     return '';
   }
  
   require_once( ABSPATH.'/wp-admin/includes/file.php' ); 
   WP_Filesystem();
   global $wp_filesystem;

		$api =  ( isset( $jws_option['google_api'] ) && '' !== $jws_option['google_api'] ) ? $jws_option['google_api'] : '';
        

   // In metric unit. This is default
   $distance_data = $wp_filesystem->get_contents('https://maps.googleapis.com/maps/api/distancematrix/json?&origins='.urlencode($origin).'&destinations='.urlencode($destination).'&key='.$api.'');

   $distance_arr = json_decode($distance_data);

    if ($distance_arr->status=='OK') {
        $destination_addresses = $distance_arr->destination_addresses[0];
        $origin_addresses = $distance_arr->origin_addresses[0];
    } else {
      return false;
      exit();
    }

   if ($origin_addresses=="" or $destination_addresses=="") {
      return "<p>Destination or origin address not found</p>";
      exit();
   }

   // Get the elements as array
   $elements = $distance_arr->rows[0]->elements;
   
   if($elements[0]->status == 'OK') {
       $distance = $elements[0]->distance->value;
        
   }else {
      $distance = 'alo';  
   }
   
   
   return $distance;         
} 



if( ! function_exists( 'jws_get_location' ) ) {
	add_action( 'wp_ajax_location_agencies', 'jws_get_location' );
	add_action( 'wp_ajax_nopriv_location_agencies', 'jws_get_location' );
	function jws_get_location() {
          $response = array();  
		  $post_list = get_posts( array(
                'post_type'    => 'agencies',
                'numberposts' => -1,    
            ) );
             
            $posts = array();
            $number_array = array();
            $has_ct = false;
            foreach ( $post_list as $post ) {
              $id = $post->ID;
              $location = get_post_meta( $id ,'agencies_location', true );
              if(isset($_POST['agencies_location'])) {
                $check2 = check_km_location($_POST['agencies_location'],$location); 
                  if($check2 != 'alo') {
                        $check = $check2 / 1000;
                        $check = $check * 0.621371192;
                        
                        if($check <= 100) {
                             $number_array[] = $check;
                              $has_ct = true;
                        }
                        if($check >= 2) {
                            $unit_text = esc_html__(' miles','netfx');
                       }else{
                        $unit_text = esc_html__(' mile','netfx');
                       }
                      
                  } else {
                       $has_ct = false;
                       
                  } 
                  
                  
                  if($_POST['agencies_location'] == $location) {
                    $has_ct = true;
                    $number_array[] = 0;
                  }
           }
               
        }

      if($has_ct) {
           $response['status'] = 'yes'; 
           $response['content'] =  esc_html(round(min($number_array)).$unit_text);
      }else {
        
        $response['status'] = 'no'; 
        $response['content'] = esc_html__('We\'re Sorry, No Service is Available - Yet!','netfx');
      } 
  

        echo wp_json_encode( $response );
        
    	exit();
  
    };
}


if( ! function_exists( 'jws_adress_to_zipcode' ) ) {
	add_action( 'wp_ajax_address_to_zipcode', 'jws_adress_to_zipcode' );
	add_action( 'wp_ajax_nopriv_address_to_zipcode', 'jws_adress_to_zipcode' );
	function jws_adress_to_zipcode() {
    if(isset($_POST['address']) && !empty($_POST['address'])) {
      
        
        global $jws_option; 
		$api =  ( isset( $jws_option['google_api'] ) && '' !== $jws_option['google_api'] ) ? $jws_option['google_api'] : '';

        $address = sanitize_text_field($_POST['address']);
        
        
        if(function_exists('jws_get_contents')) {
          $geo = jws_get_contents('https://maps.googleapis.com/maps/api/geocode/json?key='.$api.'&address='.urlencode($address).'&sensor=false');
		}else {
		  $geo = '';
		}

        $json = json_decode($geo);
        
        foreach($json->results[0]->address_components as $adr_node) {
            if($adr_node->types[0] == 'postal_code') {
                echo esc_attr($adr_node->long_name);
            }
        }
 
    }
    die();
};
}