<?php
/**
 * JWS Grid.
 *
 * @package JWS
 */

namespace Elementor;
use Elementor\Controls_Manager;

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

/**
 * Class Module.
 */
class JWS_Grid {
    /**
     * Instance
     *
     * @since 1.2.0
     * @access private
     * @static
     *
     * @var Plugin The single instance of the class.
     */
    private static $_instance = null;
    /**
     * Instance
     *
     * Ensures only one instance of the class is loaded or can be loaded.
     *
     * @since 1.2.0
     * @access public
     *
     * @return Plugin An instance of the class.
     */
    public static function instance() {
        if (is_null(self::$_instance)) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }
    	/**
	 * Constructor.
	 */
	public function __construct() {

	


			$this->add_actions();
	

	}
	/**
	 * Add actions and set scripts dependencies required to run the widget.
	 *
	 * @since 1.12.0
	 * @access protected
	 */
	protected function add_actions() {
         add_action('elementor/element/section/section_effects/after_section_end', [$this, 'register_controls']);
            add_action('elementor/element/common/section_effects/after_section_end', [$this, 'register_controls']);




	}

        /**
	 * Enqueue scripts.
	 *
	 * Registers all the scripts defined as extension dependencies and enqueues them.
	 *
	 * @since 1.12.0
	 * @access public
	 */
	public function enqueue_scripts_line() {
	}
	/**
	 * Register Line Animation Backgrounds controls.
	 *
	 * @since 1.12.0
	 * @access public
	 * @param object $element for current element.
	 * @param object $section_id for section ID.
	 * @param array  $args for section args.
	 */
	public function register_controls( $element ) {
        
			$element->start_controls_section(
				'jws_grid',
				[
					'tab'   => Controls_Manager::TAB_ADVANCED,
					/* translators: %s admin link */
					'label' =>  esc_html__( 'JWS Grid', 'netfx' ) , 
				]
			);
            $element->add_control(
				'jws_enable_grid_row',
                [
                    'label'        => esc_html__( 'Make this row "In Grid"', 'netfx' ),
                    'type'         => Controls_Manager::SELECT,
                    'default'      => 'yes',
                    'options'      => [
                        'no'      => esc_html__( 'No', 'netfx' ),
                        'section' => esc_html__( 'Yes', 'netfx' ),
                    ],
                    'prefix_class' => 'jws-row-grid-'
                ]
			);
			$element->end_controls_section();

	}

	/**
	 * Render Particles Background output on the frontend.
	 *
	 * Written in PHP and used to generate the final HTML.
	 *
	 * @since 1.12.0
	 * @access public
	 * @param object $element for current element.
	 */
	public function _before_render( $element ) {

	   }
   /**
	 * Render Particles Background output in the editor.
	 *
	 * Written as a Backbone JavaScript template and used to generate the live preview.
	 *
	 * @since 1.12.0
	 * @access public
	 * @param object $template for current template.
	 * @param object $widget for current widget.
	 */
	public function _print_template( $template, $widget ) {
    }
}
// Instantiate Plugin Class
JWS_Grid::instance();
