<?php
/**
 * View template for Clever blog Advanced.
 *
 * @package jws\Templates
 * @copyright 2018 CleverSoft. All rights reserved.
 */

$blog_ids = $default_asset = $tab_arr = $jws_json_config = '';
if($settings['blog_ids'] && is_array($settings['blog_ids'])){
    $blog_ids = $settings['blog_ids'];
}

if ( is_front_page() ) {
    $paged = (get_query_var('page')) ? get_query_var('page') : 1;   
} else {
    $paged = (get_query_var('paged')) ? get_query_var('paged') : 1; 
}
$meta_query = WC()->query->get_meta_query();

$blog_attr = array(
    'post_type'         => 'post',
    'posts_per_page'    => $settings['posts_per_page'],
    'paged'             => $paged,
    'orderby'           => $settings['orderby'],
    'order'             => $settings['order'],
    'post__in'      => $blog_ids,
);


	if ( '' !== $settings['query_exclude_ids'] ) {

		$exclude_ids = $settings['query_exclude_ids'];

		$blog_attr['post__not_in'] = $exclude_ids;
	}



$blog_attr['blog_cat']=array();
if($settings['tab_blogs'] != 'asset'){
    if($settings['default_category'] != '' && $settings['default_category'] != 'all'){
        $blog_attr['blog_cat'] = $settings['default_category'];
    }
    else{
        if($settings['tab_categories']){
            $blog_attr['blog_cat'] = implode(',', $settings['tab_categories']);
        }
    }
    $default_asset = $settings['asset_type'];
}
else{
    $default_asset = $settings['default_asset'];
    if($settings['tab_categories_for_asset'] != '' && $settings['tab_categories_for_asset'] != 'all'){
        $blog_attr['blog_cat'] = implode(',', $settings['tab_categories_for_asset']);
    }
}


$settings['blog_attr'] = $blog_attr; 

$jws_wrap_class         = "jws-blog-element jws-blogs-wrap append-class jws-wrap";
$jws_json_config = '';
$class_row  ='';

$class_row .= ' jws_blogs_'.$settings['blogs_layouts'].'';
$class_row .= ' jws_pagination_'.$settings['pagination_type'].' ';
$class_row .= 'row';
if($settings['layout_type'] == 'grid'){
    $class_row .= ' grid-layout';
} 
    $grid_class = 'jws-blog-item '.$settings['display'].' col-xl-' . $settings['columns'] . ' col-lg-' . $settings['columns_tablet'] . ' col-md-' . $settings['columns_tablet'] . ' col-' . $settings['columns_mobile'] .'';


if($settings['layout_type'] == 'carousel'){
    $class_row .= ' slider-layout carousel';
    if($settings['arrow_postion']) {
        $class_row .= ' '.$settings['arrow_postion'];
            
    }   
    
    $grid_class .= ' slick-slide';
     
    $jws_wrap_class        .= ' ' . $settings['nav_position'];
    $jws_wrap_class        .= ' jws_blogs_slider';
    $jws_wrap_class .= '  jws-grid-lg-' . $settings['slides_to_show']['size'] . '-cols jws-grid-md-' . $settings['slides_to_show_tablet']['size'] . '-cols jws-grid-' . $settings['slides_to_show_mobile']['size'] . '-cols';

    $settings['autoplay'] ? $settings['autoplay'] : $settings['autoplay'] = 'false';
    $settings['autoplay_tablet'] ? $settings['autoplay_tablet'] : $settings['autoplay_tablet'] = 'false';
    $settings['autoplay_mobile'] ? $settings['autoplay_mobile'] : $settings['autoplay_mobile'] = 'false';

    $settings['show_pag'] ? $settings['show_pag'] : $settings['show_pag'] = 'false';
    $settings['show_pag_tablet'] ? $settings['show_pag_tablet'] : $settings['show_pag_tablet'] = 'false';
    $settings['show_pag_mobile'] ? $settings['show_pag_mobile'] : $settings['show_pag_mobile'] = 'false';

    $settings['show_nav'] ? $settings['show_nav'] : $settings['show_nav'] = 'false';
    $settings['show_nav_tablet'] ? $settings['show_nav_tablet'] : $settings['show_nav_tablet'] = 'false';
    $settings['show_nav_mobile'] ? $settings['show_nav_mobile'] : $settings['show_nav_mobile'] = 'false';
    $settings['speed']?$settings['speed']:$settings['speed']=3000;

    $jws_json_config = '{
        "slides_to_show" : ' . $settings['slides_to_show']['size'] . ',
        "slides_to_show_tablet" : ' . $settings['slides_to_show_tablet']['size'] . ',
        "slides_to_show_mobile" : ' . $settings['slides_to_show_mobile']['size'] . ',

        "speed": ' . $settings['speed'] . ',
        "scroll": ' . $settings['scroll'] . ',

        "autoplay": ' . $settings['autoplay'] . ',
        "autoplay_tablet": ' . $settings['autoplay_tablet'] . ',
        "autoplay_mobile": ' . $settings['autoplay_mobile'] . ',

        "show_pag": ' . $settings['show_pag'] . ',
        "show_pag_tablet": ' . $settings['show_pag_tablet'] . ',
        "show_pag_mobile": ' . $settings['show_pag_mobile'] . ',

        "show_nav": ' . $settings['show_nav'] . ',
        "show_nav_tablet": ' . $settings['show_nav_tablet'] . ',
        "show_nav_mobile": ' . $settings['show_nav_mobile'] . ',
        "wrap": "div.blogs"
    }';
}
$tab_arr = array(
    'blog_ids'           => $settings['blog_ids'],
    'orderby'               => $settings['orderby'],
    'blogs_layouts'      => $settings['blogs_layouts'],
    'order'                 => $settings['order'],
    'posts_per_page'        => $settings['posts_per_page'],
    'tab_categories'     => $blog_attr['blog_cat'],
    'display' => $settings['display'],
    'layout_type' => $settings['layout_type'],
    'columns' => $settings['columns'],
    'columns_tablet' => $settings['columns_tablet'],
    'columns_mobile' => $settings['columns_mobile'],
    'readmore_text' => $settings['readmore_text'],
    'excerpt_length' => $settings['excerpt_length'],
    'excerpt_more'=> $settings['excerpt_more'],
    'blog_image_size' =>  $settings['blog_image_size'],
);

if(function_exists('zoo_blog_hover_effect')) {
	$class_row .= ' hover-effect-' . zoo_blog_hover_effect();
}

$blog_query = new WP_Query($settings['blog_attr']);

?>
<div class="<?php echo esc_attr($jws_wrap_class) ?> " 
    data-args='<?php echo json_encode($tab_arr); ?>'
    data-url="<?php echo esc_url(admin_url('admin-ajax.php')); ?>"
    data-jws-config='<?php echo esc_attr($jws_json_config) ?>'>

    <div class="jws-head-blog-tab has-tabs <?php echo esc_attr($settings['title'] ? 'has-border' : '');?>">
        <?php if ($settings['title'] != '') :
            printf('<h3 %s>%s</h3>',$this->get_render_attribute_string('title'), $settings['title']); 
        endif; ?>
      
            <ul class="jws-ajax-load tab-cate ct_ul_ol">
                <?php
                if($settings['default_category'] && isset(get_term_by('slug',$settings['default_category'], 'category')->name)){
                    echo '<li><a href="'.get_term_link($settings['default_category'], 'category').'" class="ajax-load active" data-type="blog_cat" data-value="'.$settings['default_category'].'" >' . get_term_by('slug',$settings['default_category'], 'category')->name . '</a></li>';
                }
                if($settings['tab_categories']){
                    foreach ($settings['tab_categories'] as $blog_cat_slug) {
                        $blog_cat = get_term_by('slug', $blog_cat_slug, 'category');
                        $selected = '';
                        if(isset($blog_cat->slug)){
                            if (isset($settings['blog_attr']['blog_cat']) && $settings['blog_attr']['blog_cat'] == $blog_cat->slug) {
                                $selected = 'jws-selected';
                            }
                            $ajax_load = 'redirect';
                            if($settings['ajax_load']=='yes'){
                                $ajax_load = ' ajax-load';
                            }
                            echo '<li><a href="' . esc_url(get_term_link($blog_cat->slug, 'category')) . '"
                            class="' . esc_attr($selected) . $ajax_load . '" 
                            data-type="blog_cat" data-value="' . esc_attr($blog_cat->slug) . '" 
                            title="' . esc_attr($blog_cat->name) . '">' . esc_html($blog_cat->name) . '</a></li>';
                        }
                        
                    } 
                }
                ?>
            </ul>
   </ul>

</div>
<div class="blogs-tab">
    <div class="blogs blog-content <?php echo esc_attr($class_row) ?>">
    
        <?php 
            while ($blog_query->have_posts()) : $blog_query->the_post();
                $class_slug = '';
                $format = has_post_format() ? get_post_format() : 'no_format'; 
                echo '<article class="'.$grid_class.' '.$format.$class_slug.'">';
 
                       include( 'layout/'.$settings['blogs_layouts'].'.php' );
                       
                echo '</article>';
            endwhile;
        ?>
    
    </div>
</div>
<?php if($settings['pagination'] != 'none' && $settings['tab_blogs'] == 'none' && $settings['layout_type'] == 'grid') : ?>
  <?php
  $zoo_pag_type = $settings['pagination'];
  ?>
  <?php if($zoo_pag_type == 'ajaxload' || $zoo_pag_type == 'infinity'):
        wp_enqueue_script('infinite-scroll');
  ?>
    <div class="pagination-ajax">
    <?php endif; ?>
    <?php
   // jws_pagination(3, $blog_query, '', '<i class="zoo-icon-long-arrow-left"></i> ' . esc_html__('', 'netfx'), esc_html__('', 'netfx') . ' <i class="zoo-icon-long-arrow-right"></i>');
    ?>
    <?php if($zoo_pag_type == 'ajaxload' || $zoo_pag_type == 'infinity') : ?>

        <div class="scroller-status">
            <div class="infinite-scroll-request">
                <div class="pagination-loading"><span class="loading"><?php echo esc_html__('LOADING...','netfx') ?></span></div>
            </div>
            <p class="infinite-scroll-last"><?php echo esc_html__('All items loaded','netfx'); ?></p>
            <p class="infinite-scroll-error"><?php echo esc_html__('No more page','netfx'); ?></p>
        </div>
        <?php if ($zoo_pag_type == 'ajaxload') { ?>
            <p class="view-more-button"><span><?php echo esc_html__('Load More','netfx') ?></span></p>
        <?php } ?>
    </div>
<?php endif; ?>
<?php endif; ?>
<?php
wp_reset_postdata();
?>
    <?php if ( $blog_query->max_num_pages > 1 && $settings['pagination_type'] == 'load_more') { ?>
        <div class="jws_blog_pagination">
             <a class="jws-blogs-load-more" href="#"><span class="more_blog"><?php echo esc_html($settings['pagination_loadmore_label']); ?></span><?php if(!empty($settings['pagination_loadmore_label2'])) echo '<span class="all_loaded">'.$settings['pagination_loadmore_label2'].'</span>' ?></a>
        </div>
    <?php } ?>
     <?php if ( $blog_query->max_num_pages > 1 && $settings['pagination_type'] == 'arrow') { ?>
        <div class="jws_blog_pagination<?php echo ' arrow_'.$settings['arrow_layouts'].''; ?>">
            <div class="jws-blogs-load-prev jws_woo_arrow disabled"><span class="<?php echo esc_attr($settings['icon_prev']); ?>"></span></div>
            <div  class="jws-blogs-load-next jws_woo_arrow"><span class="<?php echo esc_attr($settings['icon_next']); ?>"></span></div>
        </div>
    <?php } ?>
    <?php if ( $blog_query->max_num_pages > 1 && $settings['pagination_type'] == 'numbers') { ?>
        <div class="jws_blog_pagination">
            <?php echo jws_query_pagination($blog_query->max_num_pages); ?>
        </div>
    <?php } ?>
    <?php if ( $settings['pagination_type'] == 'view_all') {
        $target = $settings['view_link']['is_external'] ? ' target="_blank"' : '';
		$nofollow = $settings['view_link']['nofollow'] ? ' rel="nofollow"' : ''; 
        $line = $settings['show_line_pagination']? 'line-pagination' : '';
        ?>
        <div class="jws_blog_pagination view-all <?php echo esc_attr($line) ?>">
             <a class="jws-blogs-view-all btn-button btn-dark" href="<?php echo esc_url($settings['view_link']['url']); ?>" <?php echo esc_attr($target.$nofollow); ?>><span class="view_all_blog"><?php echo esc_html($settings['pagination_loadmore_label']); ?></span><span class="btn-icon btn-icon-custom">  </span>   </a>
        </div>
    <?php } ?>
</div>