<?php
/**
 * The template for displaying all single posts
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/#single-post
 *
 * @package WordPress
 * @subpackage netfx
 * @since 1.0.0
 */

get_header();
?>

	<section id="primary" class="content-area">
		<main id="main" class="site-main">
            <div class="container">
            <div class="row">
                <div class="col-xl-3">
                    <?php
                            if (isset($jws_option['select-sidebar-job']) && !empty($jws_option['select-sidebar-job'])) { 
                                         echo do_shortcode('[hf_template id="' . $jws_option['select-sidebar-job'] . '"]'); 
                            }else {
                               if ( is_active_sidebar( 'sidebar-job' ) ) {
                    			     dynamic_sidebar( 'sidebar-job' );
                    		   } 
                            }	
		            ?>
                </div>
                <div class="col-xl-9">
                          <?php
                    			/* Start the Loop */
                    			while ( have_posts() ) :
                    				the_post();
                    				get_template_part( 'template-parts/content/content', 'single-job' );
                    
                    				if ( is_singular( 'attachment' ) ) {
                    					// Parent post navigation.
                    					the_post_navigation(
                    						array(
                    							/* translators: %s: parent post link */
                    							'prev_text' => sprintf( esc_html__( '<span class="meta-nav">Published in</span><span class="post-title">%s</span>', 'netfx' ), '%title' ),
                    						)
                    					);
                    				} elseif ( is_singular( 'post' ) ) {
                    					// Previous/next post navigation.
                    					the_post_navigation(
                    						array(
                    							'next_text' => '<span class="meta-nav" aria-hidden="true">' . esc_html__( 'Next Post', 'netfx' ) . '</span> ' .
                    								'<span class="screen-reader-text">' . esc_html__( 'Next post:', 'netfx' ) . '</span> <br/>' .
                    								'<span class="post-title">%title</span>',
                    							'prev_text' => '<span class="meta-nav" aria-hidden="true">' . esc_html__( 'Previous Post', 'netfx' ) . '</span> ' .
                    								'<span class="screen-reader-text">' . esc_html__( 'Previous post:', 'netfx' ) . '</span> <br/>' .
                    								'<span class="post-title">%title</span>',
                    						)
                    					);
                    				}
                    
                    				// If comments are open or we have at least one comment, load up the comment template.
                    				if ( comments_open() || get_comments_number() ) {
                    					comments_template();
                    				}
                    
                    			endwhile; // End of the loop.
                			?>
                </div>
            </div>
            </div>
		</main><!-- #main -->
	</section><!-- #primary -->

<?php
get_footer();
