<?php
/**
 * Template part for displaying posts
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/
 *
 * @package WordPress
 * @subpackage netfx
 * @since 1.0.0
 */
global $jws_option; 
$comments_number = get_comments_number();
?>

<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
            <div class="entry_content">
                <div class="container">
                    <?php the_content(); ?> 
                </div>
            </div>
            <header>
            <div class="container">
                <div class="row row-eq-height">
                    <div class="col-xl-6 col-lg-6 col-12">
                        <?php 
                            echo jws_get_tags();
                        ?>
                    </div>
                    <div class="col-xl-6 col-lg-6 col-12 meta-right">
                         <span class="like_number">
                            <i class="fas fa-heart"></i>
                            <?php $like_count = get_post_meta(get_the_ID(), '_jws_love', true); echo esc_html($like_count); echo esc_html__(' LIKES','netfx'); ?>
                        </span>
                        <?php 
                            if(function_exists('jws_share_buttons')) echo jws_share_buttons('');
                        ?>
                    </div>
                </div>
                <?php 
                    get_template_part( 'template-parts/content/blog/single/template/author_box/author_box1' );
                    get_template_part( 'template-parts/content/blog/single/template/nav/nav2' );
                ?>
              </div>  
           </header>
           <?php 
                 if((isset($jws_option['select-related-blog']) && !empty($jws_option['select-related-blog'])) && ($layout = 'layout1' || $layout = 'layout2')) {
                    $related = get_posts( array( 'category__in' => wp_get_post_categories($post->ID), 'numberposts' => 100,'post_type' => 'post', 'post__not_in' => array($post->ID) ) );
                    if(isset($related[0])) :  ?>  
                      <div class="post_related">
                          <?php echo do_shortcode('[hf_template id="' . $jws_option['select-related-blog'] . '"]'); ?>
                      </div>
           <?php endif; }  ?>
           <footer>
            <div class="container">
                <?php
                     // If comments are open or we have at least one comment, load up the comment template.
    				if ( comments_open() || get_comments_number() ) {
    					comments_template();
    				}
                 ?>
              </div>   
            </footer>   
		<?php
		wp_link_pages(
			array(
				'before' => '<div class="page-links">' . esc_html__( 'Pages:', 'netfx' ),
				'after'  => '</d iv>',
			)
		);
		?>

</article><!-- #post-<?php the_ID(); ?> -->
