
<?php
/**
 * The Template for displaying product archives, including the main shop page which is a post type archive
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/archive-product.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see https://docs.woocommerce.com/document/template-structure/
 * @package WooCommerce/Templates
 * @version 3.4.0
 */

defined( 'ABSPATH' ) || exit;
global $jws_option; 
$class='';
if(isset($_GET['layout']) && $_GET['layout']) { 
  $layout = $_GET['layout'];
}else {
 $layout = (isset($jws_option['shop_layout']) && !empty($jws_option['shop_layout']) ) ? $jws_option['shop_layout'] : 'layout1';
}

if(isset($_GET['full']) && $_GET['full'] == 'full-width') { 
  $fullwidth = (isset($_GET['full']) && $_GET['full']) ? $_GET['full'] : false; 
}else {
  $fullwidth = (isset($jws_option['shop-fullwidth-switch']) && $jws_option['shop-fullwidth-switch']) ? $jws_option['shop-fullwidth-switch'] : false;  
}
if(isset($_GET['type']) && $_GET['type']) { 
  
  $layout_type = $_GET['type']; 
}else{
     $layout_type = (isset($jws_option['shop_type']) && $jws_option['shop_type']) ? $jws_option['shop_type'] : 'grid';  
 
  
}
if($layout_type == 'masonry' || $layout_type == 'metro') {
        $class .= 'masonry';
}else {
         $class .= $layout_type;
}


if(isset($_GET['sidebar']) && $_GET['sidebar']) { 
  $position = $_GET['sidebar'];  
}else{
  $position = (isset($jws_option['shop_position_sidebar']) && $jws_option['shop_position_sidebar']) ? $jws_option['shop_position_sidebar'] : 'no_sidebar';  
}
if(isset($_GET['bottom_banner']) && $_GET['bottom_banner']) { 
  $show_bottom_banner = $_GET['bottom_banner'];  
}else{
  $show_bottom_banner = (isset($jws_option['shop_bottom_banner']) && $jws_option['shop_bottom_banner']) ? $jws_option['shop_bottom_banner'] : 0;  
}
if($position == 'no_sidebar') {
  
   $content_col = 'shop-content col-12'; 
   $sidebar_col = 'shop-sidebar main-sidebar sidebar_sticky ';
   $class .= ' no_sidebar';
}else {
      
    if(isset($_GET['shop_sidebar_column']) && $_GET['shop_sidebar_column'] == '3') {
       $content_col = 'shop-content col-xl-9 col-lg-12 col-12';
       $sidebar_col = 'shop-sidebar main-sidebar col-xl-3 col-lg-12 col-12'; 
    }elseif(isset($_GET['shop_sidebar_column']) && $_GET['shop_sidebar_column'] == '4') {
        $content_col = 'shop-content col-xl-8 col-lg-12 col-12';
       $sidebar_col = 'shop-sidebar main-sidebar col-xl-4 col-lg-12 col-12'; 
    }elseif((isset($jws_option['shop_sidebar_column']) && $jws_option['shop_sidebar_column'])=='3'){
        $content_col = 'shop-content col-xl-9 col-lg-12 col-12';
       $sidebar_col = 'shop-sidebar main-sidebar col-xl-3 col-lg-12 col-12'; 
    }elseif((isset($jws_option['shop_sidebar_column']) && $jws_option['shop_sidebar_column'])=='4'){
        $content_col = 'shop-content col-xl-8 col-lg-12 col-12';
       $sidebar_col = 'shop-sidebar main-sidebar col-xl-4 col-lg-12 col-12'; 
    }else {
         $content_col = 'shop-content col-xl-9 col-lg-12 col-12';
       $sidebar_col = 'shop-sidebar main-sidebar col-xl-3 col-lg-12 col-12'; 
    }
  
   
   $class .= ' has_sidebar'; 
}
if($layout_type == 'masonry' || $layout_type == 'metro') {
        $data_layout = "masonry";
}else {
        $data_layout = "fitRows";   
}
if(isset($_GET['columns']) && $_GET['columns']) { 
    $columns = (isset($_GET['columns']) && !empty($_GET['columns'])) ? esc_attr($_GET['columns']) : '3';
}else {
    $columns = (isset($jws_option['shop_columns']) && !empty($jws_option['shop_columns'])) ? esc_attr($jws_option['shop_columns']) : '3';
}
if($layout == "layout_one_column") {
     $columns_tablet = '12';   
}elseif(isset($_GET['columns_tablet']) && $_GET['columns_tablet']) { 
   $columns_tablet = (isset($_GET['columns_tablet']) && !empty($_GET['columns_tablet'])) ? esc_attr($_GET['columns_tablet']) : '4';   
}else {
  $columns_tablet = (isset($jws_option['shop_columns_tablet']) && !empty($jws_option['shop_columns_tablet'])) ? esc_attr($jws_option['shop_columns_tablet']) : '4';  
}
if(isset($_GET['pagination']) && $_GET['pagination']) { 
  $pagination_type = $_GET['pagination'];  
 
}else{
  $pagination_type = (isset($jws_option['shop_pagination']) && $jws_option['shop_pagination']) ? $jws_option['shop_pagination'] : 'load_more';  
}
if($layout == "layout_one_column") {
     $columns_mobile = '12';   
}elseif(isset($_GET['columns_mobile']) && $_GET['columns_mobile']) { 
  $columns_mobile = (isset($_GET['columns_mobile']) && !empty($_GET['columns_mobile'])) ? esc_attr($_GET['columns_mobile']) : '12'; 
}else {
  $columns_mobile = (isset($jws_option['shop_columns_mobile']) && !empty($jws_option['shop_columns_mobile'])) ? esc_attr($jws_option['shop_columns_mobile']) : '12';
}
$class_see = "inner-flip";
$sizer = '<div class="grid-sizer col-xl-'.esc_attr($columns).' col-lg-'.esc_attr($columns_tablet).' col-md-'.esc_attr($columns_tablet).' col-'.esc_attr($columns_mobile).'"></div>';
$data  = 'data-masonry-product=\'{"selector":".product-item", "columnWidth":".grid-sizer","layoutMode":"'.$data_layout.'"}\'';
get_header();
  if((isset($jws_option['show_shop_titlebar']) && $jws_option['show_shop_titlebar']) || !isset($jws_option['show_shop_titlebar']) ) :
  $delimiter = '/';
   ?>
    <div class="jws-title-bar-wrap">
		<div class="container">
			<div class="jws-title-bar">
			<h2 class="jws-text-ellipsis"><?php echo jws_page_title(); ?></h2>
             <?php if(isset($jws_option['sub_title_shop']) && !empty($jws_option['sub_title_shop']) ) : ?>
                  <span class="subtitle"><?php echo esc_html($jws_option['sub_title_shop']);?></span>
             <?php endif; ?>
             <?php if(isset($jws_option['show_breadcrumbs_shop']) && $jws_option['show_breadcrumbs_shop'] ) : ?>
			<div class="jws-path">
					<div class="jws-path-inner">
						<?php echo jws_page_breadcrumb($delimiter); ?>
					</div>
			</div>
            <?php endif;?>
			</div>
		</div>
	</div>
<?php endif;?>


<div class="shop-page">
 <div class="container">
     <?php if(isset($_GET['top_filter'])) { 
          $show_top_filter = $_GET['top_filter'];  
        }else{
          $show_top_filter = (isset($jws_option['shop_top_filter']) && $jws_option['shop_top_filter']) ? $jws_option['shop_top_filter'] : 0;  
        }
        if($show_top_filter !=0) {
            do_action('archive_product_filter_top');
        }
     ?>
  
</div>
<div class="<?php echo wp_kses_post(($fullwidth) ? 'no_container' : 'container'); ?>">

    <div class="row jws_woo_main_products">
         <?php if($position == 'left' && is_active_sidebar( 'sidebar-shop' )) { ?>
            <div class="<?php echo esc_attr($sidebar_col).esc_attr(' '.$position); ?>">
                <div class="sidebar-inner">
                <?php
                   
                            dynamic_sidebar( 'sidebar-shop' );
                    
                ?>
            </div>
            </div>
        <?php } ?>
        <div class="<?php echo esc_attr($content_col);?>">
        <?php
        /**
         * Hook: woocommerce_before_main_content.
         *
         * @hooked woocommerce_output_content_wrapper - 10 (outputs opening divs for the content)
         * @hooked WC_Structured_Data::generate_website_data() - 30
         */
        
        
        if ( woocommerce_product_loop() ) {
        
        	/**
        	 * Hook: woocommerce_before_shop_loop.
        	 *
        	 * @hooked woocommerce_output_all_notices - 10
        	 * @hooked woocommerce_result_count - 20
        	 * @hooked woocommerce_catalog_ordering - 30
        	 */
        	do_action( 'woocommerce_before_shop_loop' );
        
        	woocommerce_product_loop_start();
            if($layout == "layout_one_column") {}
            $layout_one_col = ($layout == "layout_one_column") ? 'layout_one_col' : '';
        ?>
        <div class="product-shop-listing <?php echo esc_attr($layout_one_col);  ?>">
        <div class="products row product-list jws-<?php echo esc_attr($class);  ?> jws_products_content-<?php echo esc_attr($layout); ?>" <?php echo wp_kses_post( $data ); ?>>
    
        <?php if($layout_type=="metro" || $layout_type=="masonry" ||$pagination_type=='load_more' ) {
            echo wp_kses_post( $sizer );
        }?> 
        						
               
        <?php
        	if ( wc_get_loop_prop( 'total' ) ) {
        		while ( have_posts() ) {
        			the_post();
        
        			/**
        			 * Hook: woocommerce_shop_loop.
        			 */
        			do_action( 'woocommerce_shop_loop' );
                    ?>
                    <div class="product-item <?php echo esc_attr($class_see)?> col-xl-<?php echo esc_attr($columns); ?> col-lg-<?php echo esc_attr($columns_tablet); ?> col-md-6 col-<?php echo esc_attr($columns_mobile); ?>">
                        <?php wc_get_template_part( 'content', 'product' );?>
                    
                    </div> 
        			
        		<?php }
        	}
        
        	woocommerce_product_loop_end();
        
        	/**
        	 * Hook: woocommerce_after_shop_loop.
        	 *
        	 * @hooked woocommerce_pagination - 10
        	 */
        	do_action( 'woocommerce_after_shop_loop' );
        } else {?>
            <div class="jws-remove-filters-container">
                    <?php

                    //the_widget('WC_Widget_Layered_Nav_Filters', array(), array());
                    //do_action('jws_remove_filter');

                    ?>
                </div>
                <div class="jws_woo_loader_price"></div>     
        
        <?php	/**
        	 * Hook: woocommerce_no_products_found.
        	 *
        	 * @hooked wc_no_products_found - 10
        	 */
             wc_get_template_part( 'archive', 'no-product' );
        	
        }
        
        /**
         * Hook: woocommerce_after_main_content.
         *
         * @hooked woocommerce_output_content_wrapper_end - 10 (outputs closing divs for the content)
         */

        ?>
        
        </div>
        </div>
        <?php if($position == 'right' && is_active_sidebar( 'sidebar-shop' )) { ?>
            <div class="<?php echo esc_attr($sidebar_col).esc_attr(' '.$position); ?>">
                
                    <div class="<?php echo esc_attr($sidebar_col).esc_attr(' '.$position); ?>">
                <div class="sidebar-inner">
                <?php
                    
                            dynamic_sidebar( 'sidebar-shop' );
                  
                ?>
            </div>
            </div>
                ?>
            </div>
        <?php } ?>
    </div>
</div>
</div>
<?php
  if($show_bottom_banner==1):
     if(isset($jws_option['select-bottom-banner']) && !empty($jws_option['select-bottom-banner'])) {
          echo do_shortcode('[hf_template id="' . $jws_option['select-bottom-banner'] . '"]');
        }
   
   endif;
 ?>
 <?php 
    
    $para = '';
    if(isset($_GET['sidebar'])){
      $para .= '&sidebar='.$_GET['sidebar'];
    }
    if(isset($_GET['type'])){
     $para .= '&type='.$_GET['type'];
    }
    if(isset($_GET['result_count'])){
      $para .= '&result_count='.$_GET['result_count'];
    }
     if(isset($_GET['columns'])){
      $para .= '&columns='.$_GET['columns'];
    }
    if(isset($_GET['layout_width'])){
      $para .= '&layout_width='.$_GET['layout_width'];
    }
    if(isset($_GET['layout'])){
      $para .= '&layout='.$_GET['layout'];
    }
     if(isset($_GET['shop_sidebar_column'])){
      $para .= '&shop_sidebar_column='.$_GET['shop_sidebar_column'];
    }
     if(isset($_GET['orderby_product'])){
      $para .= '&orderby_product='.$_GET['orderby_product'];
    }
     if(isset($_GET['result_count'])){
      $para .= '&result_count='.$_GET['result_count'];
    }
    if(isset($_GET['top_filter'])){
      $para .= '&top_filter='.$_GET['top_filter'];
    }
    if(isset($_GET['review_columns'])){
      $para .= '&review_columns='.$_GET['review_columns'];
    }
    

 ?>
 <input type="hidden" name="url-get" value="<?php echo esc_attr($para)  ?>"/>
<?php

get_footer( 'shop' );

?>