<?php
/**
 * The template for displaying product content in the single-product.php template
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/content-single-product.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see     https://docs.woocommerce.com/document/template-structure/
 * @package WooCommerce/Templates
 * @version 3.6.0
 */

defined( 'ABSPATH' ) || exit;

global $product,$jws_option;
  
/**
 * Hook: woocommerce_before_single_product.
 *
 * @hooked wc_print_notices - 10
 */
do_action( 'woocommerce_before_single_product' );

if ( post_password_required() ) {
	echo get_the_password_form(); // WPCS: XSS ok.
	return;
}
  $single_product_layout_meta = get_post_meta( get_the_ID(), 'single-layout', true );
if(isset($single_product_layout_meta) && $single_product_layout_meta) { 
  $layout = $single_product_layout_meta;
}else {
 $layout = (isset($jws_option['shop_single_layout']) && !empty($jws_option['shop_single_layout'])) ? $jws_option['shop_single_layout'] : 'layout1';
}
  $single_entry_column = get_post_meta( get_the_ID(), 'entry_column', true );
$single_entry_column = get_post_meta(get_the_ID(), 'entry_column', true);
 if(isset($single_entry_column) && $single_entry_column && $single_entry_column !=0) { 
  $entry_column = $single_entry_column;
}else {
 $entry_column = (isset($jws_option['entry_column']) && !empty($jws_option['entry_column'])) ? $jws_option['entry_column'] : '5';
}
if($entry_column == 5){
    $image_column= 'col-xl-7';
    $entry_content_width = 'col-xl-5';
}elseif($entry_column == 7){
    $image_column= 'col-xl-5';
    $entry_content_width = 'col-xl-7';
}elseif($entry_column == 4){
    $image_column= 'col-xl-8';
    $entry_content_width = 'col-xl-4';
}elseif($entry_column == 3){
    $image_column= 'col-xl-9';
    $entry_content_width = 'col-xl-3';
}elseif($entry_column == 6){
    $image_column= 'col-xl-6';
    $entry_content_width = 'col-xl-6';
}
?>
<div id="product-<?php the_ID(); ?>" <?php wc_product_class( '', $product ); ?>>
    <div class="main-product <?php echo esc_attr($layout); ?>">
       <div class="container">
<div class="row">
        <div class="<?php echo esc_attr($image_column)?> col-lg-6 col-md-12 col-12">
            	<?php
                	/**
                	 * Hook: woocommerce_before_single_product_summary.
                	 *
                	 * @hooked woocommerce_show_product_sale_flash - 10
                	 * @hooked woocommerce_show_product_images - 20
                	 */
                	do_action( 'woocommerce_before_single_product_summary' );
            	?>
        </div>
        <div class="<?php echo esc_attr($entry_content_width)?> col-lg-6 col-md-12 col-12">
        	<div class="summary entry-summary">
        		<?php 
        		  woocommerce_template_single_title();
        		  woocommerce_template_single_rating();
        		  woocommerce_template_single_price();
                   if (defined( 'YITH_WC_Product_Countdown' ) ) {  ywpc_get_template( get_the_ID(), 'single-product' ); }
                  
                 
        		  woocommerce_template_single_excerpt();
        		  woocommerce_template_single_add_to_cart();
                  ?>

                  <?php
                  jws_product_product_summary_custom();
        		  woocommerce_template_single_meta();
        		?>
        	</div>
        </div>
    </div>


	<?php
    
	/**
	 * Hook: woocommerce_after_single_product_summary.
	 *
	 * @hooked woocommerce_output_product_data_tabs - 10
	 * @hooked woocommerce_upsell_display - 15
	 * @hooked woocommerce_output_related_products - 20
	 */
	do_action( 'woocommerce_after_single_product_summary' );
    do_action('woocommerce_recently_viewed_products');
?>
</div>
    </div>
</div>

<?php do_action( 'woocommerce_after_single_product' ); ?>

