<?php
/**
 * The Template for displaying all single products
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/single-product.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see         https://docs.woocommerce.com/document/template-structure/
 * @package     WooCommerce/Templates
 * @version     1.6.4
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}
global $product,$jws_option;
$show_bottom_banner = (isset($jws_option['single_product_bottom_banner']) && $jws_option['single_product_bottom_banner']) ? $jws_option['single_product_bottom_banner'] : 0;
get_header( 'shop' ); 
  if((isset($jws_option['show_shop_titlebar']) && $jws_option['show_shop_titlebar']) || !isset($jws_option['show_shop_titlebar'])  ) :
  $delimiter = '/';
   ?>
    <div class="jws-title-bar-wrap">
		<div class="container">
					<div class="jws-title-bar">
					<h2 class="jws-text-ellipsis"><?php echo jws_page_title(); ?></h2>
                     <?php if(isset($jws_option['sub_title_shop']) && !empty($jws_option['sub_title_shop']) ) : ?>
                          <span class="subtitle"><?php echo esc_html($jws_option['sub_title_shop']);?></span>
                     <?php endif; ?>
                     <?php if(isset($jws_option['show_breadcrumbs_shop']) && $jws_option['show_breadcrumbs_shop'] ) : ?>
					<div class="jws-path">
							<div class="jws-path-inner">
								<?php echo jws_page_breadcrumb($delimiter); ?>
							</div>
					</div>
                    <?php endif;?>
					</div>
		</div>
	</div>
<?php endif;?>
<div class="shop-single">


	<?php
		/**
		 * woocommerce_before_main_content hook.
		 *
		 * @hooked woocommerce_output_content_wrapper - 10 (outputs opening divs for the content)
		 * @hooked woocommerce_breadcrumb - 20
		 */
		do_action( 'woocommerce_before_main_content' );
	?>

		<?php while ( have_posts() ) : ?>
			<?php the_post(); ?>

			<?php wc_get_template_part( 'content', 'single-product' ); ?>

		<?php endwhile; // end of the loop. ?>

	<?php
		/**
		 * woocommerce_after_main_content hook.
		 *
		 * @hooked woocommerce_output_content_wrapper_end - 10 (outputs closing divs for the content)
		 */
		do_action( 'woocommerce_after_main_content' );
	?>


</div>
<?php
wp_enqueue_script('addthis-widget');

  if($show_bottom_banner==1):
     if(isset($jws_option['select-product-page-bottom-banner']) && !empty($jws_option['select-product-page-bottom-banner'])) {
          echo do_shortcode('[hf_template id="' . $jws_option['select-product-page-bottom-banner'] . '"]');
        }
   
   endif;

get_footer( 'shop' );

/* Omit closing PHP tag at the end of PHP files to avoid "headers already sent" issues. */