<?php
/**
 * Single Product Image
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/single-product/product-image.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see     https://docs.woocommerce.com/document/template-structure/
 * @package WooCommerce/Templates
 * @version 3.5.1
 */

defined( 'ABSPATH' ) || exit;
            global $jws_option;
          $single_product_layout_meta = get_post_meta( get_the_ID(), 'single-layout', true );
            if(isset($single_product_layout_meta) && $single_product_layout_meta) { 
              $layout = $single_product_layout_meta;
            }else {
             $layout = (isset($jws_option['shop_single_layout']) && !empty($jws_option['shop_single_layout'])) ? $jws_option['shop_single_layout'] : 'layout1';
            }

            // Note: `wc_get_gallery_image_html` was added in WC 3.3.2 and did not exist prior. This check protects against theme overrides being used on older versions of WC.
        if ( ! function_exists( 'wc_get_gallery_image_html' ) ) {
        	return;
        }
        
        global $post, $product,$jws_option;
        $thumbnail_id=get_post_thumbnail_id($product->get_id());
        if(empty($thumbnail_id)) {
            	return;
        }
        $thumb_image_size = 'woocommerce_single';
        $columns           = apply_filters( 'woocommerce_product_thumbnails_columns', 4 );
        $thumbnail_size    = apply_filters( 'woocommerce_product_thumbnails_large_size', 'full' );
        $post_thumbnail_id = $product->get_image_id();
        $full_size_image   = wp_get_attachment_image_src( $post_thumbnail_id, $thumbnail_size );
        $single_thumbmail = get_post_meta( get_the_ID(), 'thumbnail_position', true );
       
        if(isset($single_thumbmail) && $single_thumbmail) { 
          $thumbnail_position = $single_thumbmail;
        }else {
         $thumbnail_position = (isset($jws_option['thumbnail_position']) && !empty($jws_option['thumbnail_position'])) ? $jws_option['thumbnail_position'] : 'left';
        }

        $wrapper_classes   = apply_filters( 'woocommerce_single_product_image_gallery_classes', array(
        	'woocommerce-product-gallery',
            'thumbnail_position_'.$thumbnail_position, /* themeoption */
            'image-action-popup', /* themeoption */
        	'woocommerce-product-gallery--' . ( $product->get_image_id() ? 'with-images' : 'without-images' ),
        	'woocommerce-product-gallery--columns-' . absint( $columns ),
        	'images',
            'image_slider',
        ) );
        ?>
        <div class="<?php echo esc_attr( implode( ' ', array_map( 'sanitize_html_class', $wrapper_classes ) ) ); ?>" data-columns="<?php echo esc_attr( $columns ); ?>" style="opacity: 0; transition: opacity .25s ease-in-out;">
        	<div class="jws_main_image">
            <?php jws_product_label(); ?>
          	<figure class=" <?php if($layout!="layout4" && $layout!="layout5") { echo esc_attr('woocommerce-product-gallery__wrapper_slider'); }?> woocommerce-product-gallery__wrapper">
			<?php
				$attributes = array(
					'title'                   => get_post_field( 'post_title', $post_thumbnail_id ),
					'data-caption'            => get_post_field( 'post_excerpt', $post_thumbnail_id ),
					'data-src'                => $full_size_image[0],
					'data-large_image'        => $full_size_image[0],
					'data-large_image_width'  => $full_size_image[1],
					'data-large_image_height' => $full_size_image[2],
					'class'                   => 'wp-post-image',
				);

				if ( $product->get_image_id() ) {
					$html  = '<div class="product-image-wrap"><figure data-thumb="' . get_the_post_thumbnail_url( $post->ID, 'woocommerce_thumbnail' ) . '" class="woocommerce-product-gallery__image"><a href="' . esc_url( $full_size_image[0] ) . '">';
					$html .= get_the_post_thumbnail( $post->ID, $thumb_image_size, $attributes );
					$html .= '</a></figure></div>';
				} else {
				    if(!empty($placeholder_size) ) {
				        		$html  = '<div class="product-image-wrap"><figure data-thumb="' . esc_url( wc_placeholder_img_src( $placeholder_size ) ) . '" class="woocommerce-product-gallery__image--placeholder"><a href="' . esc_url( wc_placeholder_img_src( $placeholder_size ) ) . '">';

					$html .= sprintf( '<img src="%s" alt="%s" data-src="%s" data-large_image="%s" data-large_image_width="700" data-large_image_height="800" class="attachment-woocommerce_single size-woocommerce_single wp-post-image" />', esc_url( wc_placeholder_img_src( $placeholder_size ) ), esc_html__( 'Awaiting product image', 'netfx' ), esc_url( wc_placeholder_img_src( $placeholder_size ) ), esc_url( wc_placeholder_img_src( $placeholder_size ) ) );
					
					$html .= '</a></figure></div>';
				    }
			
				}
				echo apply_filters( 'woocommerce_single_product_image_thumbnail_html', $html, $post_thumbnail_id );

			    do_action( 'woocommerce_product_thumbnails' );

			?>
		</figure>
        <span class="zoom-out"><svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" id="Capa_1" x="0px" y="0px" viewBox="0 0 490.675 490.675" style="enable-background:new 0 0 490.675 490.675;" xml:space="preserve">
            <g>
            	<path style="fill:#455A64;" d="M245.342,490.671c-5.891,0-10.667-4.776-10.667-10.667V10.671c0-5.891,4.776-10.667,10.667-10.667   c5.891,0,10.667,4.776,10.667,10.667v469.333C256.008,485.895,251.233,490.671,245.342,490.671z"/>
            	<path style="fill:#455A64;" d="M480.008,256.004H10.675c-5.891,0-10.667-4.776-10.667-10.667s4.776-10.667,10.667-10.667h469.333   c5.891,0,10.667,4.776,10.667,10.667S485.899,256.004,480.008,256.004z"/>
            	<path style="fill:#455A64;" d="M309.342,85.338c-2.831,0.005-5.548-1.115-7.552-3.115l-56.448-56.469l-56.448,56.469   c-4.237,4.093-10.99,3.975-15.083-0.262c-3.992-4.134-3.992-10.687,0-14.82l64-64c4.165-4.164,10.917-4.164,15.083,0l64,64   c4.159,4.172,4.148,10.926-0.024,15.085C314.871,84.218,312.164,85.337,309.342,85.338z"/>
            	<path style="fill:#455A64;" d="M245.342,490.671c-2.831,0.005-5.548-1.115-7.552-3.115l-64-64   c-4.093-4.237-3.975-10.99,0.262-15.083c4.134-3.993,10.687-3.993,14.821,0l56.469,56.448l56.448-56.448   c4.237-4.093,10.99-3.975,15.083,0.262c3.993,4.134,3.993,10.687,0,14.821l-64,64C250.873,489.55,248.165,490.67,245.342,490.671z"/>
            	<path style="fill:#455A64;" d="M416.008,320.004c-5.891,0.011-10.675-4.757-10.686-10.648c-0.005-2.84,1.123-5.565,3.134-7.571   l56.469-56.448l-56.469-56.448c-4.093-4.237-3.975-10.99,0.262-15.083c4.134-3.993,10.687-3.993,14.821,0l64,64   c4.164,4.165,4.164,10.917,0,15.083l-64,64C421.54,318.884,418.832,320.004,416.008,320.004z"/>
            	<path style="fill:#455A64;" d="M74.675,320.004c-2.831,0.005-5.548-1.115-7.552-3.115l-64-64c-4.164-4.165-4.164-10.917,0-15.083   l64-64c4.237-4.092,10.99-3.975,15.083,0.262c3.992,4.134,3.992,10.687,0,14.82l-56.448,56.448l56.448,56.448   c4.171,4.16,4.179,10.914,0.019,15.085C80.224,318.876,77.508,320.004,74.675,320.004z"/>
            </g>
            <path d="M245.342,490.671c-5.891,0-10.667-4.776-10.667-10.667V10.671c0-5.891,4.776-10.667,10.667-10.667  c5.891,0,10.667,4.776,10.667,10.667v469.333C256.008,485.895,251.233,490.671,245.342,490.671z"/>
            <path d="M480.008,256.004H10.675c-5.891,0-10.667-4.776-10.667-10.667s4.776-10.667,10.667-10.667h469.333  c5.891,0,10.667,4.776,10.667,10.667S485.899,256.004,480.008,256.004z"/>
            <path d="M309.342,85.338c-2.831,0.005-5.548-1.115-7.552-3.115l-56.448-56.469l-56.448,56.469  c-4.237,4.093-10.99,3.975-15.083-0.262c-3.992-4.134-3.992-10.687,0-14.82l64-64c4.165-4.164,10.917-4.164,15.083,0l64,64  c4.159,4.172,4.148,10.926-0.024,15.085C314.871,84.218,312.164,85.337,309.342,85.338z"/>
            <path d="M245.342,490.671c-2.831,0.005-5.548-1.115-7.552-3.115l-64-64c-4.093-4.237-3.975-10.99,0.262-15.083  c4.134-3.993,10.687-3.993,14.821,0l56.469,56.448l56.448-56.448c4.237-4.093,10.99-3.975,15.083,0.262  c3.993,4.134,3.993,10.687,0,14.821l-64,64C250.873,489.55,248.165,490.67,245.342,490.671z"/>
            <path d="M416.008,320.004c-5.891,0.011-10.675-4.757-10.686-10.648c-0.005-2.84,1.123-5.565,3.134-7.571l56.469-56.448  l-56.469-56.448c-4.093-4.237-3.975-10.99,0.262-15.083c4.134-3.993,10.687-3.993,14.821,0l64,64c4.164,4.165,4.164,10.917,0,15.083  l-64,64C421.54,318.884,418.832,320.004,416.008,320.004z"/>
            <path d="M74.675,320.004c-2.831,0.005-5.548-1.115-7.552-3.115l-64-64c-4.164-4.165-4.164-10.917,0-15.083l64-64  c4.237-4.092,10.99-3.975,15.083,0.262c3.992,4.134,3.992,10.687,0,14.82l-56.448,56.448l56.448,56.448  c4.171,4.16,4.179,10.914,0.019,15.085C80.224,318.876,77.508,320.004,74.675,320.004z"/>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            </svg></span>
       
        </div>
  </div>
        